; *********************************************************************
; * Ficheiro:  lab3.asm
; * Descrio: Exemplifica o acesso a um teclado.
; *            L uma linha do teclado, verificando se h alguma tecla
; *            premida nessa linha.
; *
; * Nota: Observe a forma como se acede aos perifricos de 8 bits
; *       atravs da instruo MOVB
; *********************************************************************

; **********************************************************************
; * Constantes
; **********************************************************************
; ATENO: constantes hexadecimais que comecem por uma letra devem ter 0 antes.
;          Isto no altera o valor de 16 bits e permite distinguir nmeros de identificadores
DISPLAYS   EQU 0A000H  ; endereo dos displays de 7 segmentos (perifrico POUT-1)
TEC_LIN    EQU 0C000H  ; endereo das linhas do teclado (perifrico POUT-2)
TEC_COL    EQU 0E000H  ; endereo das colunas do teclado (perifrico PIN)
LINHA      EQU 8       ; linha a testar (4 linha, 1000b)
MASCARA    EQU 0FH     ; para isolar os 4 bits de menor peso, ao ler as colunas do teclado

; **********************************************************************
; * Cdigo
; **********************************************************************
PLACE      0
inicio:		
; inicializaes
    MOV  R2, TEC_LIN   ; endereo do perifrico das linhas
    MOV  R3, TEC_COL   ; endereo do perifrico das colunas
    MOV  R4, DISPLAYS  ; endereo do perifrico dos displays
    MOV  R5, MASCARA   ; para isolar os 4 bits de menor peso, ao ler as colunas do teclado

; corpo principal do programa
ciclo:
    MOV  R1, 0 
    MOVB [R4], R1      ; escreve linha e coluna a zero nos displays

espera_tecla:          ; neste ciclo espera-se at uma tecla ser premida
    MOV  R1, LINHA     ; testar a linha 4 
    MOVB [R2], R1      ; escrever no perifrico de sada (linhas)
    MOVB R0, [R3]      ; ler do perifrico de entrada (colunas)
    AND  R0, R5        ; elimina bits para alm dos bits 0-3
    CMP  R0, 0         ; h tecla premida?
    JZ   espera_tecla  ; se nenhuma tecla premida, repete
                       ; vai mostrar a linha e a coluna da tecla
    SHL  R1, 4         ; coloca linha no nibble high
    OR   R1, R0        ; junta coluna (nibble low)
    MOVB [R4], R1      ; escreve linha e coluna nos displays
    
ha_tecla:              ; neste ciclo espera-se at NENHUMA tecla estar premida
    MOV  R1, LINHA     ; testar a linha 4  (R1 tinha sido alterado)
    MOVB [R2], R1      ; escrever no perifrico de sada (linhas)
    MOVB R0, [R3]      ; ler do perifrico de entrada (colunas)
    AND  R0, R5        ; elimina bits para alm dos bits 0-3
    CMP  R0, 0         ; h tecla premida?
    JNZ  ha_tecla      ; se ainda houver uma tecla premida, espera at no haver
    JMP  ciclo         ; repete ciclo

